Skip to content

# Saved credentail access

## Saved credentials in EEPROM

AutoConnect stores the established WiFi connection in the EEPROM of the ESP8266/ESP32 module and equips the class to access it from the sketch. You can read, write or erase the credentials using this class individually. It's AutoConnectCredential class which provides the access method to the saved credentials in EEPROM.1

## AutoConnectCredential

### Include header

    #include <AutoConnectCredential.h>

### Constructors

    AutoConnectCredential();

AutoConnectCredential default constructor. The default offset value is 0. If the offset value is 0, the credential area starts from the top of the EEPROM. AutoConnect sometimes overwrites data when using this area with user sketch.

    AutoConnectCredential(uint16_t offset);

Parameter
  offsetSpecies offset from the top of the EEPROM for the credential area together. The offset value is from 0 to the flash sector size.

### Public member functions

#### entries

    uint8_t entries(void)

Returns number of entries as contained credentials.

Return value
  Number of entries as contained credentials.

#### load

    int8_t load(const char* ssid, struct station_config* config)

Load a credential entry and store to config.

Parameters
  ssidSSID to be loaded.
  configstation_config
Return value
  Save the specified SSID's credential entry to station_config pointed to by the parameter as config. -1 is returned if the SSID is not saved.

#### load

    bool load(int8_t entry, struct station_config* config)

Load a credential entry and store to config.

Parameters
  entrySpecifies the index number based 0 to be loaded.
  configstation_config
Return value
  Save the specified credential entry to station_config pointed to by the parameter as config. -1 is returned if specified number is not saved.

#### save

    bool save(const struct station_config* config)

Save a credential entry.

Parameter
  configstation_config to be saved.
Return value
  trueSuccessfully saved.
  falseFailed to save.

#### del

    bool del(const char* ssid)

Delete a credential the specified SSID.

Parameter
  ssidSSID to be deleted.
Return value
  trueSuccessfully deleted.
  falseFailed to delete.

## The data structures

### station_config

A structure is included in the ESP8266 SDK. You can use it in the sketch like as follows:

    extern "C" {
    #include <user_interface.h>
    }

    struct station_config {
      uint8 ssid[32];
      uint8 password[64];
      uint8 bssid_set;
      uint8 bssid[6];
    };

### The credential entry

A data structure of the credential saving area in EEPROM as the below. 2

Byte offset | Length | Value
--- | --- | ---
0 | 8 | AC_CREDT
8 | 1 | Number of contained entries (uint8_t)
9 | 2 | Container size, excluding size of AC_CREDT and size of the number of entries(width for uint16_t type).
11 | variable | SSID terminated by 0x00. Max length is 32 bytes.
variable | variable | Password plain text terminated by 0x00. Max length is 64 bytes.
variable | 6 | BSSID
variable |  | Contained the next entries. (Continuation SSID+Password+BSSID)
variable | 1 | 0x00. End of container.

1. An example using AutoConnectCredential is provided as an example of a library sketch to delete saved credentials. ↩

2. There may be 0xff as an invalid data in the credential saving area. The 0xff area would be reused. ↩